<?php

namespace Drupal\component_schema\Component\Schema;

use Drupal\Core\Template\Attribute;
use Drupal\Core\TypedData\TypedData;

/**
 * An Attribute component element.
 */
class ComponentAttribute extends TypedData implements TypedComponentVariableInterface {

  /**
   * The data value.
   *
   * @var \Drupal\Core\Template\Attribute
   */
  protected $value;

  /**
   * Overrides \Drupal\Core\TypedData\TypedData::applyDefaultValue().
   *
   */
  public function applyDefaultValue($notify = TRUE) {
    // Apply a default if specified in the definition.
    $this
      ->setValue(new Attribute(), $notify);
    return $this;
  }

  /**
   *
   */
  public function initializeValue(&$value, Attribute $attribute = NULL) {
    // Set a default value.
    if (is_null($value)) {
      $value = new Attribute();
    }
    // Attributes data may be passed in array form rather than Attribute.
    // Standardize on Attribute.
    elseif (is_array($value)) {
      $value = new Attribute($value);
    }

  }

  /**
   * Gets valid configuration data keys.
   *
   * @return array
   *   Array of valid configuration data keys.
   */
  protected function getAllKeys() {
    return array_keys((array) $this->value);
  }

}
