<?php

namespace Drupal\component_schema\Component\Schema;

use Drupal\Core\TypedData\MapDataDefinition;

/**
 * A typed component data definition class for defining maps.
 */
class ComponentDataDefinition extends MapDataDefinition implements ComponentDataDefinitionInterface {

  /**
   * {@inheritdoc}
   */
  public function getStylesheetTemplate() {
    return $this->definition['stylesheet_template'] ?? NULL;
  }

  /**
   * {@inheritdoc}
   */
  public function getComponentTemplate() {
    assert(!empty($this->definition['component_template']), 'Required component_template property is present');
    return $this->definition['component_template'];
  }

  /**
   * {@inheritdoc}
   */
  public function getGroup() {
    assert(!empty($this->definition['group']), 'Required group property is present');
    return $this->definition['group'];
  }

  /**
   * {@inheritdoc}
   */
  public function getDocumentationUrl() {
    return $this->definition['documentation_url'] ?? NULL;
  }

  /**
   * {@inheritdoc}
   */
  public function getExtensionName() {
    assert(!empty($this->definition['extension_name']), 'Required extension_name property is present');
    return $this->definition['extension_name'];
  }

  /**
   * {@inheritdoc}
   */
  public function getExtensionType() {
    assert(!empty($this->definition['extension_type']), 'Required extension_type property is present');
    return $this->definition['extension_type'];
  }

}
