<?php

namespace Drupal\component_schema\Component\Schema;

use Drupal\Core\Config\Schema\Sequence;
use Drupal\Core\Template\Attribute;

/**
 * The mapping data type for components.
 */
class ComponentSequence extends Sequence implements TypedComponentVariableInterface {

  use ComponentVariableArrayElementTrait;

  /**
   * {@inheritdoc}
   */
  public function initializeValue(&$value, Attribute $attribute = NULL) {
    $original_value = $this->value;
    // We need to set the value to be able to iterate through child elements.
    $this->value = $value;

    $this->doInitializeValue($value, $attribute);
    $this->processBreakpoints($value, $attribute);

    // Restore the original value.
    $this->value = $original_value;
  }

  /**
   * Processes breakpoints.
   *
   * @param mixed &$value
   *   A component variable value.
   * @param \Drupal\Core\Template\Attribute $attribute
   *   An Attribute object.
   *
   * @todo Finish this method.
   * @see https://www.drupal.org/project/component_schema/issues/3154376
   */
  protected function processBreakpoints(&$value, $attribute) {
    if (is_iterable($value) && count($value) === 1) {

    }
  }

}
