<?php

namespace Drupal\component_schema\Component\Schema;

trait ComponentVariableDataDefinitionTrait {

  /**
   * {@inheritdoc}
   */
  public function providesClass() {
    return !empty($this->definition['provides_class']);
  }

  /**
   * {@inheritdoc}
   */
  public function providesAttribute() {
    return !empty($this->definition['provides_attribute']);
  }

  /**
   * {@inheritdoc}
   */
  public function getProvidedName() {
    return $this->definition['provided_name'] ?? NULL;
  }

  /**
   * {@inheritdoc}
   */
  public function getProvidedValue() {
    return $this->definition['provided_value'] ?? NULL;
  }

  /**
   * {@inheritdoc}
   */
  public function supportsBreakpoints() {
    return $this->definition['supports_breakpoints'] ?? NULL;
  }

  /**
   * {@inheritdoc}
   */
  public function getDocumentationUrl() {
    return $this->definition['documentation_url'] ?? NULL;
  }

  /**
   * {@inheritdoc}
   */
  public function getDefault() {
    return $this->definition['default'] ?? NULL;
  }

}
