<?php

namespace Drupal\component_schema\Component\Schema;

use Drupal\Core\Template\Attribute;
use Drupal\Core\TypedData\TypedDataInterface;

/**
 * Interface for typed component data objects.
 */
interface TypedComponentVariableInterface extends TypedDataInterface {

  /**
   * The name of a property for the attribute data type.
   */
  const ATTRIBUTES_PROPERTY_NAME = 'attributes';

  /**
   * Initializes a value.
   *
   * @param mixed &$value
   *   A component variable value.
   * @param \Drupal\Core\Template\Attribute $attribute
   *   (optional) An Attribute object.
   */
  public function initializeValue(&$value, Attribute $attribute = NULL);

}
